/****************************************************************************
 *									    *
 * DVSEIZE ON|OFF - inhibit DESQview task swapping			    *
 *		    Russ Herman, Dec. 1990				    *
 *									    *
 ****************************************************************************/
#include <conio.h>
#include <stddef.h>
#include <stdlib.h>
#include <dvapi.h>
#include <dvapi2.h>
#define VERSION "1.0"

main(int argc, char *argv[])
{
    unsigned int dvver;
    int onoff, numarg;
    char tbuf[18];

    /* Validate params */
    numarg = (argc == 2);
    if (numarg)
	onoff = ((strcmpi(argv[1],"ON" ) == 0) ? 2 : 0) +
		((strcmpi(argv[1],"OFF") == 0) ? 1 : 0);
    if (!numarg || !onoff) {
	cputs("Usage: DVSEIZE ON|OFF\r\n");
	exit(1);
	}
    /* Validate DESQview */
    if ((dvver=api_dvpresent()) == 0) {
	cputs("DESQView not running\r\n");
	exit(0);
	}
    if (dvver < (0x200+23)) {
	cputs("Needs DESQview 2.23 or later\r\n");
	exit(0);
	}
    else {
	api_init();
	api_level(0x200+23);  /* Enable 2.23 features */
	}

    numarg = api_getcrit(); /* now get the nesting level */
    itoa(numarg, tbuf, 10); /* convert to char string for display */
    switch(onoff) {
	case 1:
	    /* was OFF */
	    if (numarg != 1) {
		/* if not one, show value (perhaps ok, perhaps not) */
		cputs("DESQview critical region nesting level is ");
		cputs(tbuf);
		cputs("\r\n");
		}
	    if (numarg > 0)
		api_endc(); /* decr critical region nesting level */
	    if (numarg == 1) {
		api_cancel();
		api_pause();
		api_exit();
		}
	    break;
	case 2:
	    /* was ON */
	    cputs("DVSEIZE ver." VERSION "\r\n");
	    api_beginc();  /* tally critical region nesting level */
	    win_topsys(win_me()); /*boost this task */
	    break;
	default:
	    /* inpossible */
	    cputs("dvseize: internal error\r\n");
	}
    exit(0);
}
